// Licensed Materials - Property of IBM 
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2008



package com.ibm.websphere.batch.devframework.datastreams.bdsadapter;

/**
 * @author Antani/Neeraj
 * 
 * This interface serves as a template for the Batch Data Input streams
 */

public interface AbstractBatchDataInputStream  {

	/**
	 * Return a boolean indicating if there 
	 * is unread data in the Input Stream
	 * @return boolean indicating if there is more data to be read
	 * @throws Exception
	 */
	public  boolean hasNext() throws Exception;
	
	/**
	 * Return the next record 
	 * @return an object representing the next record in the inputstream
	 * @throws Exception
	 */
	public  Object read() throws Exception;
	
	/**
	 * Return the next record based on the input parameters.
	 * @param parameters
	 * @return
	 * @throws Exception
	 */
	public  Object read(Object parameters) throws Exception;
	
	
	/**
	 * Returns the header data if any
	 * @return
	 */
	public Object fetchHeader();
}
