// Licensed Materials - Property of IBM 
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2008


package com.ibm.websphere.batch.devframework.datastreams.bdsadapter;

/**
 * @author Ulrich Seelbach / Neeraj
 * 
 * This interface serves as a template for the framework 
 *  Batch Data Output streams
 */

public interface AbstractBatchDataOutputStream  {

	/**
	 * Writes the given record to the output stream
	 * @param record
	 * @throws Exception
	 */
	public  void write(Object record) throws Exception;
	
	/**
	 * Flushes the output stream
	 * @throws Exception
	 */
	public  void flush() throws Exception;
	
	/**
	 * Writes header data
	 * @param record
	 * @throws Exception
	 */
	public void writeHeader(Object record) throws Exception;
}
