// Licensed Materials - Property of IBM 
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2008

package com.ibm.websphere.batch.devframework.datastreams.patternadapter;

import com.ibm.pdq.runtime.Data;
import java.util.Iterator;
import java.util.Properties;

public interface PureQueryReaderPattern
{

	/**
	 * This method is called by the Batch container during step setup. The properties passed
	 * in are the ones provided by the user in the xJCL BDS level properties
	 * @param properties
	 */
    public  void initialize(Properties properties);

    /**
     * Invoked by the container during each iteration of the batch loop. This obtains
     * the next record using the given Iterator object
     * @param iterator
     * @return
     */
    public  Object fetchRecord(Iterator iterator);

    /**
     * Returns the Iterator based on the passed Data object that will be use to iterate over the records
     * @param data
     * @return
     */
    public  Iterator getInitialIterator(Data data);

    /**
     * Returns the Iterator based on the passed Data object repositioned based on the restartToken
     * @param data
     * @param s
     * @return
     */
    public  Iterator getRestartIterator(Data data, String restartToken);

    /**
     * Invoked before a checkpoint is taken to save the restartToken that will be used in case of a restart
     * @return
     */
    public  String getRestartTokens();
}
