// Licensed Materials - Property of IBM 
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2008
package com.ibm.websphere.batch.devframework.datastreams.patterns;

import java.util.Properties;

import com.ibm.websphere.batch.BatchContainerDataStreamException;
import com.ibm.websphere.batch.devframework.configuration.BDSFWLogger;
import com.ibm.websphere.batch.devframework.datastreams.patternadapter.LocalJDBCConnection;

public class LocalJDBCCallableStatementReader extends JDBCCallableStatementReader {
	/**
	 * Creates a local JDBC connection based on the properties specified
	 * in the xJCL
	 */
	
	public void initialize(Properties props) {
		logger = new BDSFWLogger(props);
		jdbcConn = new LocalJDBCConnection();
		jdbcConn.initialize(props);
		super.initialize(props);
	}

	/**
	 * opens a JDBC connection
	 */
	public void open() throws BatchContainerDataStreamException {
		
		jdbcConn.open();
	}
	
	/**
	 * Closes a JDBC connection
	 */
	public void close() throws BatchContainerDataStreamException {
		jdbcConn.close();
	}

}
