// Licensed Materials - Property of IBM 
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2008

package com.ibm.websphere.batch.devframework.datastreams.patterns;

import java.io.BufferedOutputStream;
import java.util.Properties;

import com.ibm.jzos.ZFile;
import com.ibm.websphere.batch.BatchContainerDataStreamException;
import com.ibm.websphere.batch.devframework.configuration.BDSFrameworkConstants;
import com.ibm.websphere.batch.devframework.datastreams.patternadapter.BDSFileByteWriter;

public class ZFileStreamOrientedByteWriter extends BDSFileByteWriter {

	public static final String CLASSNAME = ZFileStreamOrientedByteWriter.class.getName();
	protected String dsname = "";
	protected String ds_parameters = " wt";
	protected ZFile zFile;
	
	public void initialize(Properties props) {
		dsname = getRequiredProperty(props,BDSFrameworkConstants.DSNAME_KEY);
	//	if (prop != null)
	//	{
	///		this.dsname = prop;
//		}				
		
		String prop = props.getProperty(BDSFrameworkConstants.DSParameters_KEY);
		if (prop != null)
		{
			this.ds_parameters = prop;
		}
				
		super.initialize(props);
	}

	
	public long getCurrentPosition() {
		try
		{
			writer.flush();
			return zFile.tell();
		}
		catch (Throwable t)
		{
			throw new RuntimeException("Failed to retrieve the current position of the zFile.", t);
		}
	}

	public void open() throws BatchContainerDataStreamException {		
		String methodName = "open";
		if(isPerformanceMeasurementEnabled)
			perfAnalyzer.startMeasurement(methodName);
        try {
            // Try to open existing dataset.
            //zFile = new ZFile("//'" + dsname + "'", "r+b" + modeString);
        	zFile = new ZFile("//'" + dsname + "'", ds_parameters);            
            writer = new BufferedOutputStream(zFile.getOutputStream());
            
        } catch (Throwable t) {
            throw new BatchContainerDataStreamException(t);
        }		
        if(isPerformanceMeasurementEnabled)
			perfAnalyzer.endMeasurementAndSave(methodName);
	}

	public void setPosition(long position) {
		try {
			zFile.seek(position,0);
		} 
		catch (Throwable t) {			
			throw new RuntimeException("Failed to set position of zFile", t);
		}
	}

}
