// Licensed Materials - Property of IBM 
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2008

package com.ibm.websphere.batch.devframework.datastreams.patterns;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Properties;

import com.ibm.jzos.ZFile;
import com.ibm.websphere.batch.devframework.configuration.BDSFrameworkConstants;
import com.ibm.websphere.batch.devframework.datastreams.patternadapter.BDSFileReader;


public class ZFileStreamOrientedTextReader extends BDSFileReader {
	public static final String CLASSNAME = ZFileStreamOrientedTextReader.class.getName();

	protected String dsname = "";
	protected String ds_parameters = " rt";
	protected ZFile zFile;
	protected String defaultFileEncoding = "CP1047";


	public void initialize(Properties props) {
		
		dsname = getRequiredProperty(props,BDSFrameworkConstants.DSNAME_KEY);
	//	if (prop != null)
	//	{
	//		this.dsname = prop;
	//	}
		
		String prop = props.getProperty(BDSFrameworkConstants.DSParameters_KEY);
		if (prop != null)
		{
			this.ds_parameters = prop;
		}
		super.initialize(props);
	}

	public void open() {
		String methodName = "open";
		if(isPerformanceMeasurementEnabled)
			perfAnalyzer.startMeasurement(methodName);
		try
		{
			//zFile = new ZFile("//'" + dsname + "'", "rb,type=record,recfm=" + recfm + ",lrecl=" + lrecl +",blksize=" + blksize);
			zFile = new ZFile("//'" + dsname + "'", ds_parameters);  
			InputStream istream = zFile.getInputStream();
			
			if (this.fileEncoding != null)
			{
				if (logger.isDebugEnabled())
        			logger.debug("ZFileStreamOrientedTextReader.open(). File.encoding= " + fileEncoding);
				reader = new BufferedReader(new InputStreamReader(istream, fileEncoding));
			}
			else 
			{
				if (logger.isDebugEnabled())
        			logger.debug("ZFileStreamOrientedTextReader.open(). File.encoding= " + fileEncoding);
				reader = new BufferedReader(new InputStreamReader(istream, defaultFileEncoding));
			}
			fileReaderImpl.processHeader(reader);
		}
		catch (Throwable t)
		{
			throw new RuntimeException(t);
		}     
		if(isPerformanceMeasurementEnabled)
			perfAnalyzer.endMeasurementAndSave(methodName);
	}
}
