// Licensed Materials - Property of IBM 
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2008

/**
 * @author Snehal/Neeraj
 * This interface is to be implemented by the user wishing to leverage the GenericBatchStep
 * capability of the framework.
 */
package com.ibm.websphere.batch.devframework.steps.technologyadapters;

import java.util.Properties;

public interface BatchRecordProcessor {
	
	/**
	 * This method is invoked during step setup to allow any initialization to occur
	 * @param props
	 */
	public void initialize(Properties props);
	
	/**
	 * This method is invoked at the beginning of the step to process any header information
	 * read by an input stream
	 * @param record
	 * @return
	 * @throws Exception
	 */
	public Object processRecord(Object record) throws Exception;
	
	/**
	 * This method is invoked during job destruction. A step return code is returned
	 * that specifies whether the step was complete or there was an error etc. Valid
	 * return codes are specified in com.ibm.websphere.batch.BatchConstants
	 * @return
	 */
	public int completeProcessing();
}
