// Licensed Materials - Property of IBM 
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2008

package com.ibm.websphere.batch.devframework.test.sample.steps;

import java.util.Properties;

import com.ibm.websphere.batch.BatchConstants;
import com.ibm.websphere.batch.BatchJobStepInterface;

public class PingStep implements BatchJobStepInterface {

	public String iterationsKey = "iterations";
	protected int max_iterations = 50000;
	protected int iterations = 0;
	protected Properties props;
	
	public void createJobStep() {
		
		String prop = props.getProperty(iterationsKey);
		if (prop != null)
		{
			try
			{
				max_iterations = Integer.valueOf(prop).intValue();				
			}
			catch (Exception e)
			{
				System.out.println("Error parsing iterations value for PingStep. Defaulting to: " + max_iterations);
			}
		}
	}

	public int destroyJobStep() {		
		return 0;
	}

	public Properties getProperties() {
		return this.props;
	}

	public int processJobStep() {
		
		if (iterations >= max_iterations)
			return BatchConstants.STEP_COMPLETE;
		else
		{
			iterations++;
			return BatchConstants.STEP_CONTINUE;
		}
	}

	public void setProperties(Properties props) {
		this.props = props;
	}

}
